Sophie

Sophie

distrib > Fedora > 17 > i386 > media > updates > by-pkgid > 1667c8ea70e0b665a2e26660748536e6 > files > 11

etckeeper-1.4-1.fc17.noarch.rpm

#!/bin/sh
set -e

cleanup () {
	if [ -n "$logfile" ]; then
		rm -f "$logfile"
	fi
}
if [ -n "$1" ]; then
	trap cleanup EXIT
	logfile="$(mktemp -t etckeeper-$VCS.XXXXXXXXXX)"
	if [ "x$1" = "x--stdin" ]; then
		cat > "$logfile"
	else
		if [ "x$1" = "x-m" ]; then
			shift 1
		fi
		echo "$1" > "$logfile"
	fi
else
	logfile=""
fi

hostname=`hostname`
hostname="${hostname%%.*}"
dnsdomainname=`dnsdomainname 2>/dev/null || true`
if [ -n "$dnsdomainname" ]; then
	hostname="$hostname.$dnsdomainname"
fi

USER=
if [ -n "$SUDO_USER" ]; then
	USER="$SUDO_USER"
else
	# try to check tty ownership, in case user su'd to root
	TTY="$(tty 2>/dev/null || true)"
	if [ -n "$TTY" ] && [ -c "$TTY" ]; then
		USER="$(find "$TTY" -printf "%u")"
	fi
fi

if [ "$VCS" = git ] && [ -d .git ]; then
	if [ -n "$USER" ]; then
		if [ -z "$GIT_AUTHOR_NAME" ]; then
			export GIT_AUTHOR_NAME="$USER"
		fi
		if [ -z "$GIT_AUTHOR_EMAIL" ]; then
			export GIT_AUTHOR_EMAIL="$USER@$hostname"
		fi
		if [ -z "$GIT_COMMITTER_EMAIL" ]; then
			export GIT_COMMITTER_EMAIL=`whoami`"@$hostname"
		fi
	fi
	if [ -n "$logfile" ]; then
		git commit $GIT_COMMIT_OPTIONS -F "$logfile"
	else
		git commit $GIT_COMMIT_OPTIONS
	fi
elif [ "$VCS" = hg ] && [ -d .hg ]; then
	if [ -n "$USER" ]; then
		export LOGNAME="$USER"
	fi
	if [ -z "$HGUSER" ]; then
		export HGUSER="$USER@$hostname"
	fi
	if [ -n "$logfile" ]; then
		hg commit $HG_COMMIT_OPTIONS -l "$logfile"
	else
		hg commit $HG_COMMIT_OPTIONS
	fi
elif [ "$VCS" = bzr ] && [ -d .bzr ]; then
	if [ -z "$EMAIL" ] && [ -n "$USER" ]; then
		export EMAIL="$USER <$USER@$hostname>"
	fi
	if [ -n "$logfile" ]; then
		bzr commit $BZR_COMMIT_OPTIONS -F "$logfile"
	else
		bzr commit $BZR_COMMIT_OPTIONS
	fi
elif [ "$VCS" = darcs ] && [ -d _darcs ]; then
	if [ -z "$USER" ]; then
		USER=root
	fi
	if [ -n "$logfile" ]; then
		darcs record --author="$USER" $DARCS_COMMIT_OPTIONS --logfile="$logfile"
	else
		darcs record --author="$USER" $DARCS_COMMIT_OPTIONS
	fi
fi